
#include "projet.h"




class MyApp: public wxApp
{
	public:
		virtual bool OnInit(void);
		virtual int OnExit();
};


// Main proc
IMPLEMENT_APP(MyApp)


bool MyApp::OnInit(void)
{

    // Create the main frame window
    MyFrame *frame = new MyFrame(NULL, -1, _T("TPLO11 Sample"), wxPoint(0, 0), wxSize(1000, 1000), -1);
	frame->SetSizeHints( 500, 400 );	
    

	// Make a menubar
    wxMenu *file_menu = new wxMenu;
    file_menu->Append(DB_OPEN, _T("&Ouvrir fichier XML"));
    file_menu->Append(DB_SAVE, _T("&Enregistrer"));
    file_menu->Append(DB_SAVEAS, _T("Enregistrer &sous"));
	file_menu->Append(DB_CLOSE, _T("&Fermer"));
	file_menu->AppendSeparator();
    file_menu->Append(DB_QUIT, _T("&Quitter"));
    
	wxMenuBar *menu_bar = new wxMenuBar;
    menu_bar->Append(file_menu, _T("&Fichier"));
    frame->SetMenuBar(menu_bar);





    SetTopWindow(frame);

	// Show the frame
    frame->Show(TRUE);
    SetTopWindow(frame);

    return TRUE;
}

int MyApp::OnExit()
{
    // exit code is 0, everything is ok
    return 0;
}



BEGIN_EVENT_TABLE(MyFrame, wxFrame)
	/* Menu Events */
    EVT_MENU(DB_QUIT,		MyFrame::Quit)
	EVT_MENU(DB_OPEN,		MyFrame::Open)
	EVT_MENU(DB_SAVE,		MyFrame::Enregistrer)
	EVT_MENU(DB_CLOSE,		MyFrame::Fermer)
	EVT_MENU(DB_SAVEAS,		MyFrame::EnregistrerSous)
	
	/* Widgets Events */
	EVT_BUTTON(BT_NEXT,		MyFrame::Bt_NextStudent)
	EVT_BUTTON(BT_PREV,		MyFrame::Bt_PrevStudent)
	EVT_BUTTON(BT_ADD,		MyFrame::Bt_AddStudent)
	EVT_BUTTON(BT_DROP,		MyFrame::Bt_DropStudent)
	EVT_BUTTON(BT_ALTER,	MyFrame::Bt_AlterStudent)
	EVT_BUTTON(BT_SRCH,		MyFrame::Bt_SearchStudent)
	//EVT_BUTTON(BT_SEM_CHG,	MyFrame::Bt_ActualiseGrille)
	EVT_GRID_CELL_CHANGE(MyFrame::CellChangeGrid)
	EVT_TEXT(SEM_CHANGE,	MyFrame::Bt_ActualiseGrille)
	EVT_TEXT(STUD_CHANGE,	MyFrame::Bt_SearchStudent)
	EVT_BUTTON(BT_NEW_SEM,	MyFrame::Bt_NewSemestre)
END_EVENT_TABLE()


MyFrame::MyFrame(wxWindow* parent, int id, const wxString& title, const wxPoint& pos, const wxSize& size, long style):
    wxFrame(parent, id, title, pos, size, wxDEFAULT_FRAME_STYLE)
{
    // begin wxGlade: MyFrame2::MyFrame2
    label_id = new wxStaticText(this, -1, wxT("Identifiant"));
    label_branche = new wxStaticText(this, -1, wxT("Branche"));
    label_semestre = new wxStaticText(this, -1, wxT("Semestre"));
    ctrl_id = new wxTextCtrl(this, -1, wxT(""));
    const wxString ctrl_branche_choices[] = { "Coucou" };
    ctrl_semestre = new wxComboBox(this, SEM_CHANGE, wxT(""), wxDefaultPosition, wxDefaultSize, 0, ctrl_branche_choices, wxCB_DROPDOWN);
    ctrl_branche = new wxTextCtrl(this, -1, wxT(""));
    label_nom = new wxStaticText(this, -1, wxT("Nom"));
    label_prenom = new wxStaticText(this, -1, wxT("Prnom"));
    label_tel = new wxStaticText(this, -1, wxT("Tlphone"));
    ctrl_nom = new wxTextCtrl(this, -1, wxT(""));
    ctrl_prenom = new wxTextCtrl(this, -1, wxT(""));
    ctrl_tel = new wxTextCtrl(this, -1, wxT(""));
    label_adr = new wxStaticText(this, -1, wxT("Adresse"));
    ctrl_adr = new wxTextCtrl(this, -1, wxT(""));

    button_prev =	new wxButton(this, BT_PREV, wxT("Etudiant prcdent"));
    button_next =	new wxButton(this, BT_NEXT, wxT("Etudiant suivant"));
	button_see =	new wxButton(this, BT_NEW_SEM, wxT("Ajouter un semestre"));
    //button_see =	new wxButton(this, -1, wxT("Voir ou modifier les dtails de l'tudiant"));
	//button_see =	new wxButton(this, -1, wxT("Actualiser la grille des UVs"));
    button_add =	new wxButton(this, BT_ADD, wxT("Ajouter un tudiant"));
    button_drop =	new wxButton(this, BT_DROP, wxT("Supprimer cet tudiant"));
    button_modif =	new wxButton(this, BT_ALTER, wxT("Modifier un tudiant"));
    button_search =	new wxButton(this, BT_SRCH, wxT("Rechercher un tudiant"));
    const wxString box_students_choices[] = { "Etudiants" };
    box_students =	new wxComboBox(this, STUD_CHANGE, wxT(""), wxDefaultPosition, wxDefaultSize, 0, box_students_choices, wxCB_DROPDOWN);
    ctrl_search =	new wxTextCtrl(this, -1, wxT(""));
    //button_confirm = new wxButton(this, -1, wxT("Valider cet ajout"));
    //button_cancel = new wxButton(this, -1, wxT("Annuler cet ajout"));
    grid_1 = new wxGrid(this, -1);

    set_properties();
    do_layout();
    // end wxGlade
}


void MyFrame::set_properties()
{
    // begin wxGlade: MyFrame2::set_properties
    SetTitle(wxT("Gestion des tudiants de l'UTC"));
    ctrl_semestre->SetSelection(-1);
    box_students->SetSelection(-1);
    grid_1->CreateGrid(7, 2);
    grid_1->SetColLabelValue(0, wxT("Code UV"));
    grid_1->SetColLabelValue(1, wxT("Rsultat"));
    // end wxGlade

	etudiantCourant		= -1;
	fichierCourant		= "";

	/* Disable button or text */
	button_prev->Enable(false);
	button_next->Enable(false);
}


void MyFrame::do_layout()
{
	/* Conteneur */
    wxFlexGridSizer* grid_sizer_5 = new wxFlexGridSizer(6, 1, 0, 0);

	/* Id, Branche, Semestre */
	wxGridSizer* grid_sizer_6 = new wxGridSizer(2, 3, 0, 0);
    grid_sizer_6->Add(label_id, 0, wxEXPAND, 0);
    grid_sizer_6->Add(label_branche, 0, wxEXPAND, 0);
    grid_sizer_6->Add(label_semestre, 0, wxEXPAND, 0);
    grid_sizer_6->Add(ctrl_id, 0, wxEXPAND, 0);
    grid_sizer_6->Add(ctrl_branche, 0, wxEXPAND, 0);
    grid_sizer_6->Add(ctrl_semestre, 0, wxEXPAND, 0);
	grid_sizer_5->Add(grid_sizer_6, 1, wxEXPAND, 0);



	/* nom, prenom, tlphone */
	wxGridSizer* grid_sizer_7 = new wxGridSizer(2, 3, 0, 0);
    grid_sizer_7->Add(label_nom, 0, wxEXPAND, 0);
    grid_sizer_7->Add(label_prenom, 0, wxEXPAND, 0);
    grid_sizer_7->Add(label_tel, 0, wxEXPAND, 0);
    grid_sizer_7->Add(ctrl_nom, 0, wxEXPAND, 0);
    grid_sizer_7->Add(ctrl_prenom, 0, wxEXPAND, 0);
    grid_sizer_7->Add(ctrl_tel, 0, wxEXPAND, 0);
    grid_sizer_5->Add(grid_sizer_7, 1, wxEXPAND, 0);

	/* Adresse */
	wxGridSizer* grid_sizer_8 = new wxGridSizer(1, 2, 0, 0);
    grid_sizer_8->Add(label_adr, 0, wxEXPAND, 0);
    grid_sizer_8->Add(ctrl_adr, 0, wxEXPAND, 0);
    grid_sizer_5->Add(grid_sizer_8, 1, wxEXPAND, 0);

	/* Suivant, prcdent, voir */
	wxGridSizer* grid_sizer_9 = new wxGridSizer(2, 3, 0, 0);
    grid_sizer_9->Add(button_prev, 0, wxEXPAND, 0);
    grid_sizer_9->Add(button_next, 0, wxEXPAND, 0);
    grid_sizer_9->Add(button_see, 0, wxEXPAND, 0);
    grid_sizer_9->Add(button_add, 0, wxEXPAND, 0);
    grid_sizer_9->Add(button_drop, 0, wxEXPAND, 0);
    grid_sizer_9->Add(button_modif, 0, wxEXPAND, 0);
    grid_sizer_5->Add(grid_sizer_9, 1, wxEXPAND, 0);
	
	/* Recherche */
	wxGridSizer* grid_sizer_10 = new wxGridSizer(1, 2, 0, 0);
    wxGridSizer* grid_sizer_11 = new wxGridSizer(1, 2, 0, 0);
    grid_sizer_11->Add(button_search, 0, wxEXPAND, 0);
    grid_sizer_11->Add(box_students, 0, wxEXPAND, 0);
    grid_sizer_10->Add(grid_sizer_11, 1, wxEXPAND, 0);
    grid_sizer_10->Add(ctrl_search, 0, wxEXPAND, 0);
    //grid_sizer_10->Add(button_confirm, 0, wxEXPAND, 0);
    //grid_sizer_10->Add(button_cancel, 0, wxEXPAND, 0);
    grid_sizer_5->Add(grid_sizer_10, 1, wxEXPAND, 0);

	grid_sizer_5->Add(grid_1, 1, wxEXPAND, 0);

    SetAutoLayout(true);
    SetSizer(grid_sizer_5);
    grid_sizer_5->Fit(this);
    grid_sizer_5->SetSizeHints(this);
    grid_sizer_5->AddGrowableRow(5);
    grid_sizer_5->AddGrowableCol(0);
    Layout();
	this->SendSizeEvent();
}





/* - - - - - - - - - - - - - - *\
    Methodes associes au menu
\* - - - - - - - - - - - - - - */

void MyFrame::Quit(wxCommandEvent& WXUNUSED(event))
{
	this->Close(TRUE);
}


void MyFrame::Open(wxCommandEvent& WXUNUSED(event))
{
	wxString nomfichier = wxFileSelector("Ouvrir" ,"" ,"" ,"",
          "XML files (*.xml)|*.xml",wxOPEN);
     if (!nomfichier.empty())
     {
		univ.chargeXML(fichierCourant = ws2s(nomfichier));
		/*wxString wxS;
		wxS.sprintf("%d tudiants ont t chargs.",univ.getNbStudent());
		wxMessageDialog MsgDlg(this,wxS);
		MsgDlg.ShowModal();*/

		box_students->Clear();
		for(int i=0; i<univ.getNbStudent(); i++)
			ListeEtuAjouteItem(univ.getStudent(i));

		// MaJ des widgets
		etudiantCourant = -1;
		ChoiceStudent();
     }
}


void MyFrame::EnregistrerSous(wxCommandEvent& WXUNUSED(event))
{
     wxString nomfichier = wxFileSelector("Enregistrer" ,"" ,"" ,"",
          "XML files (*.xml)|*.xml",wxSAVE);
     if (!nomfichier.empty())
     {
        univ.sauvegardeXML(fichierCourant = ws2s(nomfichier));
     }
}


void MyFrame::Enregistrer(wxCommandEvent& WXUNUSED(event))
{
     if (!fichierCourant.empty())
        univ.sauvegardeXML(fichierCourant);
     else
	 {
		 wxString nomfichier = wxFileSelector("Enregistrer" ,"" ,"" ,"",
	          "XML files (*.xml)|*.xml",wxSAVE);
		 if (!nomfichier.empty())
		 {
			univ.sauvegardeXML(fichierCourant = ws2s(nomfichier));
		 }
	 }
}


void MyFrame::Fermer(wxCommandEvent& WXUNUSED(event))
{
	wxMessageDialog dialog(this, "tes-vous sr de fermer le fichier courant ?", "Attention", wxYES_NO | wxICON_EXCLAMATION);
	if(dialog.ShowModal() == wxID_NO )
		return;
	univ.clean();
	etudiantCourant = -1;
	ChoiceStudent();
	fichierCourant.erase(); // mise  Null
}



/* - - - - - - - - - - - - - - - *\
    Methodes associes aux boutons
\* - - - - - - - - - - - - - - - */

//wxMessageBox("Bouton Previous Clicked");


void MyFrame::ListeEtuAjouteItem(const Student & s)
{
	string tmp = s.getLastName() + " " + s.getFirstName();
	box_students->Append(tmp.c_str());
}

void MyFrame::MajPrevNextButtons()
{
	if(etudiantCourant>0)
		button_prev->Enable(true);
	else
		button_prev->Enable(false);
	if(etudiantCourant<univ.getNbStudent()-1)
		button_next->Enable(true);
	else
		button_next->Enable(false);
}


void MyFrame::MajStudentsButtons()
{
	bool etat= (etudiantCourant>=0 && etudiantCourant<univ.getNbStudent());
	button_see->Enable(etat);
	button_drop->Enable(etat);
	button_modif->Enable(etat);
}


void MyFrame::afficheDonneesEtudiant(int i=0)
{
	if(i>=0)
	{
		wxString wxS;
		// Id
		wxS.sprintf("%d",univ.getStudent(i).getId());
		ctrl_id->SetValue(wxS);
		// Branche
		ctrl_branche->SetValue(s2ws(univ.getStudent(i).getBranche()));
		// Semestre
		ctrl_semestre->Clear();
		for(int j=0; j<univ.getStudent(i).getNbSemester(); j++)
		{
			string tmp;
			if(univ.getStudent(i).getSemester(j).getSeason())
				tmp = univ.getStudent(i).getSemester(j).getNumber() + " - " + SEASON_1;
			else
				tmp = univ.getStudent(i).getSemester(j).getNumber() + " - " + SEASON_2;
			ctrl_semestre->Append(tmp.c_str());
		}
		ctrl_semestre->SetSelection(-1);
		// Nom
		ctrl_nom->SetValue(s2ws(univ.getStudent(i).getLastName()));
		// Prenom
		ctrl_prenom->SetValue(s2ws(univ.getStudent(i).getFirstName()));
		// Telephone
		ctrl_tel->SetValue(s2ws(univ.getStudent(i).getPhone()));
		// Adresse
		ctrl_adr->SetValue(s2ws(univ.getStudent(i).getAddress()));
	}
	else
	{
		// on efface tous les champs
		ctrl_id->SetValue("");
		ctrl_branche->SetValue("");
		ctrl_semestre->Clear();
		ctrl_nom->SetValue("");
		ctrl_prenom->SetValue("");
		ctrl_tel->SetValue("");
		ctrl_adr->SetValue("");
	}
}


void MyFrame::MajGrilleUV()
{
	//grid_1
	int i;
	if(etudiantCourant>=0 && ctrl_semestre->GetSelection()>=0)
	{
		Semestre s = univ.getStudent(etudiantCourant).getSemester(ctrl_semestre->GetSelection());
		for(i=0; i<s.getNbUVs(); i++)
		{
			grid_1->SetCellValue(i, 0, s2ws(s.getUV(i).getCodeUv()));
			grid_1->SetCellValue(i, 1, s2ws(s.getUV(i).getResultat()));
		}
		for(int j=i; j<7; j++)
		{
			grid_1->SetCellValue(j, 0, "");
			grid_1->SetCellValue(j, 1, "");
		}
	}
	else
	{
		for(int j=0; j<7; j++)
		{
			grid_1->SetCellValue(j, 0, "");
			grid_1->SetCellValue(j, 1, "");
		}
	}


}


void MyFrame::ChoiceStudent()
{
	afficheDonneesEtudiant(etudiantCourant);
	MajPrevNextButtons();
	MajStudentsButtons();
	box_students->SetSelection(etudiantCourant);
	MajGrilleUV();
}



void MyFrame::Bt_ActualiseGrille(wxCommandEvent& WXUNUSED(event))
{
	MajGrilleUV();
}


void MyFrame::Bt_NextStudent(wxCommandEvent& WXUNUSED(event))
{
	if(univ.getNbStudent() > etudiantCourant+1)
	{
		etudiantCourant++;
		ChoiceStudent();
	}
}


void MyFrame::Bt_PrevStudent(wxCommandEvent& WXUNUSED(event))
{
	if(etudiantCourant>=0)
	{
		etudiantCourant--;
		ChoiceStudent();
	}
}


void MyFrame::Bt_AddStudent(wxCommandEvent& WXUNUSED(event))
{
	int id = atoi(ws2s(ctrl_id->GetValue()).c_str());
	if(id < 1)
		id = univ.getNbStudent()+1;

	Student s(id, ws2s(ctrl_prenom->GetValue()),
		ws2s(ctrl_nom->GetValue()), ws2s(ctrl_tel->GetValue()),
		ws2s(ctrl_adr->GetValue()), ws2s(ctrl_branche->GetValue()));

	bool dejaExistant = false;
	for(int i=0; i<univ.getNbStudent(); i++)
		if(s == univ.getStudent(i))
			dejaExistant = true;

	if(dejaExistant)
	{
		wxMessageDialog dialog(this, "L'tudiant existe dj !", "Attention", wxYES_NO | wxICON_EXCLAMATION);
		if(dialog.ShowModal() == wxID_YES )
			dejaExistant = false;
	}

	if(! dejaExistant)
	{
		univ.addStudent(s);

		etudiantCourant = univ.getNbStudent()-1;
		ChoiceStudent();
		ListeEtuAjouteItem(s);
		/*wxString wxS;
		wxS.sprintf("%d",id);
		wxMessageDialog MsgDlg(this,wxS);
		MsgDlg.ShowModal();*/
	}
}


void MyFrame::Bt_DropStudent(wxCommandEvent& WXUNUSED(event))
{
	if(etudiantCourant>=0 && etudiantCourant<univ.getNbStudent())
	{
		wxMessageDialog dialog(this, "tes-vous sr de supprimer l'tudiant ?", "Attention", wxYES_NO | wxICON_EXCLAMATION);
		if(dialog.ShowModal() == wxID_NO )
			return;

		univ.dropStudent(etudiantCourant);
		box_students->Delete(etudiantCourant);
		etudiantCourant--;
		ChoiceStudent();
	}
}



void MyFrame::Bt_AlterStudent(wxCommandEvent& WXUNUSED(event))
{
	if(etudiantCourant>=0 && etudiantCourant<univ.getNbStudent())
	{
		univ.getStudent(etudiantCourant).setId(atoi(ws2s(ctrl_id->GetValue()).c_str()));
		univ.getStudent(etudiantCourant).setLastName(ws2s(ctrl_nom->GetValue()));
		univ.getStudent(etudiantCourant).setFirstName(ws2s(ctrl_prenom->GetValue()));
		univ.getStudent(etudiantCourant).setPhone(ws2s(ctrl_tel->GetValue()));
		univ.getStudent(etudiantCourant).setAddress(ws2s(ctrl_adr->GetValue()));
		univ.getStudent(etudiantCourant).setBranche(ws2s(ctrl_branche->GetValue()));

		box_students->Clear();
		for(int i=0; i<univ.getNbStudent(); i++)
			ListeEtuAjouteItem(univ.getStudent(i));
		ChoiceStudent();
	}
}



void MyFrame::Bt_SearchStudent(wxCommandEvent& WXUNUSED(event))
{
	etudiantCourant = box_students->GetSelection();
	ChoiceStudent();
}


void MyFrame::CellChangeGrid(wxCommandEvent& WXUNUSED(event))
{
	if(etudiantCourant>=0 && ctrl_semestre->GetSelection()>=0)
	{
		string modif = ws2s(grid_1->GetCellValue(grid_1->GetGridCursorRow(),
						grid_1->GetGridCursorCol() ));

		if(univ.getStudent(etudiantCourant).getSemester(
				ctrl_semestre->GetSelection()).getNbUVs() > grid_1->GetGridCursorRow())
		{
			if(grid_1->GetGridCursorCol()==0) // modif du code UV
			{
				univ.getStudent(etudiantCourant).getSemester(
					ctrl_semestre->GetSelection()).getUV(
					grid_1->GetGridCursorRow()).setCodeUv(modif);
			}
			else
			{
				univ.getStudent(etudiantCourant).getSemester(
					ctrl_semestre->GetSelection()).getUV(
					grid_1->GetGridCursorRow()).setResultat(modif);
			}
		}
		else
		{
			if(grid_1->GetGridCursorCol()==0) // modif du code UV
			{
				univ.getStudent(etudiantCourant).getSemester(
					ctrl_semestre->GetSelection()).addUV(Uv(modif, ""));
			}
			else
			{
				univ.getStudent(etudiantCourant).getSemester(
					ctrl_semestre->GetSelection()).addUV(Uv("", modif));
			}
		}
	}
}



void MyFrame::Bt_NewSemestre(wxCommandEvent& WXUNUSED(event))
{
	if(etudiantCourant>=0)
	{
		DialogSem dialog(NULL, -1, "Ajout d'un semestre");
		if ( dialog.ShowModal() == wxID_OK )
		{
			univ.getStudent(etudiantCourant).addSemester(
				Semestre(ws2s(dialog.GetNombre()), dialog.GetSaison()));

			string tmp;
			if(dialog.GetSaison())
				tmp = ws2s(dialog.GetNombre()) + " - " + SEASON_1;
			else
				tmp = ws2s(dialog.GetNombre()) + " - " + SEASON_2;
			ctrl_semestre->Append(tmp.c_str());
		}
	}
}


