
#include <wx/wx.h>
#include <wx/image.h>
#include <wx/grid.h>


#ifndef PROJET_H
#define PROJET_H


	#include "universite.h"
	#include "dialogSem.h"

	// MenuId
	#define DB_QUIT		1000
	#define DB_OPEN		1001
	#define DB_SAVE		1002
	#define DB_SAVEAS	1003
	#define DB_CLOSE	1004


	// WidgetId
	#define BT_NEXT		2000
	#define BT_PREV		2001
	#define BT_ADD		2002
	#define BT_DROP		2003
	#define BT_ALTER	2004
	#define BT_SRCH		2005
	#define BT_SEM_CHG	2006
	#define CELL_GRID	2007
	#define SEM_CHANGE	2008
	#define STUD_CHANGE 2009
	#define BT_NEW_SEM	2010


	/* Macro pour convertir des wxSrting en String et inversement */
	#define		ws2s(as) (string((as).mb_str(wxConvLibc)))
	#define 	s2ws(s)   (wxString((s).c_str(),wxConvLibc))



	class MyFrame: public wxFrame
	{
		public:
			MyFrame(wxWindow* parent, int id, const wxString& title,
				const wxPoint& pos=wxDefaultPosition, const wxSize& size=wxDefaultSize,
				long style=wxDEFAULT_FRAME_STYLE);

			

		private:
			void set_properties();
			void do_layout();

			/* Menu Functions */
			void Quit(wxCommandEvent& WXUNUSED(event));
			void Open(wxCommandEvent& WXUNUSED(event));
			void Enregistrer(wxCommandEvent& WXUNUSED(event));
			void EnregistrerSous(wxCommandEvent& WXUNUSED(event));
			void Fermer(wxCommandEvent& WXUNUSED(event));

			/* Widgets Functions */
			void Bt_NextStudent(wxCommandEvent& WXUNUSED(event));
			void Bt_PrevStudent(wxCommandEvent& WXUNUSED(event));
			void Bt_AddStudent(wxCommandEvent& WXUNUSED(event));
			void Bt_DropStudent(wxCommandEvent& WXUNUSED(event));
			void Bt_AlterStudent(wxCommandEvent& WXUNUSED(event));
			void Bt_SearchStudent(wxCommandEvent& WXUNUSED(event));
			void Bt_ActualiseGrille(wxCommandEvent& WXUNUSED(event));
			void CellChangeGrid(wxCommandEvent& WXUNUSED(event));
			void Bt_NewSemestre(wxCommandEvent& WXUNUSED(event));

			/* Others */
			void afficheDonneesEtudiant(int);
			void MajPrevNextButtons();
			void MajStudentsButtons();
			void ChoiceStudent();
			void ListeEtuAjouteItem(const Student &);
			void MajGrilleUV();
			


			DECLARE_EVENT_TABLE()

		protected:
			wxStaticText* label_id;
			wxStaticText* label_branche;
			wxStaticText* label_semestre;
			wxTextCtrl* ctrl_id;
			wxTextCtrl* ctrl_branche;
			wxComboBox* ctrl_semestre;
			wxStaticText* label_nom;
			wxStaticText* label_prenom;
			wxStaticText* label_tel;
			wxTextCtrl* ctrl_nom;
			wxTextCtrl* ctrl_prenom;
			wxTextCtrl* ctrl_tel;
			wxStaticText* label_adr;
			wxTextCtrl* ctrl_adr;

			wxButton* button_prev;
			wxButton* button_next;
			wxButton* button_see;
			wxButton* button_add;
			wxButton* button_drop;
			wxButton* button_modif;
			wxButton* button_search;
			wxComboBox* box_students;
			wxTextCtrl* ctrl_search;
			wxButton* button_confirm;
			wxButton* button_cancel;
			wxGrid* grid_1;

			Universite univ;
			string fichierCourant;
			int etudiantCourant;
	};


#endif
