#include "semestre.h"


Semestre & Semestre::operator = (const Semestre & s)
{
	if (this != &s)
	{
		number = s.number;
		season = s.season;
		uv_S   = s.uv_S;
	}
	return *this;
}


ostream & operator << (ostream & f, const Semestre & sem)
{
	f << " Semestre : " << sem.getNumber() << " (";
	if (sem.getSeason())
		f << SEASON_2;
	else
		f << SEASON_1;

	f << ")" << endl<< "  Liste des Uvs : " << endl;

	list<Uv> uvs = sem.uv_S;
	for(list<Uv>::iterator i=uvs.begin(); i!=uvs.end(); i++)
	{
		f << *i;
	}
	f << endl;
	uvs.clear();

	return f;
}


bool Semestre::operator == (const Semestre & s) const
{
	if(number != s.number)
		return false;
	if(season != s.season)
		return false;
	return true;
}


bool Semestre::operator < (const Semestre & s) const
{
	if(number < s.number)
		return true;
	if((season < s.season) && (number == s.number))
		return true;
	return false;
}


bool Semestre::dropUV(const int index)
{
	if(index<0 || index>=uv_S.size())
		return false;

	list<Uv>::iterator it=uv_S.begin();
	for(int i=0; i<index; i++)
		it++;
	uv_S.erase(it);
	/*delete it;*/

	return true;
}



Uv & Semestre::getUV(const int index)
{
	if(index>=0 && index<uv_S.size())
	{
		list<Uv>::iterator it=uv_S.begin();
		for(int i=0; i<index; i++)
			it++;
		return *it;
	}
}



/* Tri */
void Semestre::sort()
{
	uv_S.sort();
}