

#ifndef _SEMESTRE_H_
#define _SEMESTRE_H_

/* includes */
#include "uv.h"

/* Constantes */
#define SEASON_1 "Printemps"	// false
#define SEASON_2 "Automne"		// true


class Semestre
{
	private:
		string number; // 01, 02, 03, 04
		bool season;
		list<Uv> uv_S;
		

	public:
	/* Diffrents Constructeurs */
		Semestre() : number(""), season(false) {} 
		Semestre(string num, bool saison) : number(num), season(saison) {}
		Semestre(string num, bool saison, list<Uv>listUvs) : number(num), season(saison), uv_S(listUvs) {}

	/* Destructeur */
		~Semestre() { uv_S.clear(); }
	/* Accesseurs */
		inline void setNumber(string num) { number = num; }
		inline void setSeason(bool saison) { season = saison; }
		inline void setUvs(list<Uv> uvs) { uv_S = uvs; }

		inline string getNumber() const { return number; }
		inline bool getSeason() const { return season; }
		inline const list<Uv> & getUvs() const { return uv_S; }

	/* Gestion des UVs */
		inline void addUV(const Uv & uv) { uv_S.push_back(uv); }
		bool dropUV(const int);
		Uv & getUV(const int);
		inline int getNbUVs() { return uv_S.size(); }

	/* Redfinition d'oprateurs */
		Semestre & operator = (const Semestre &);
		friend ostream & operator << (ostream &, const Semestre &);
		bool operator == (const Semestre &) const;
		bool operator < (const Semestre &) const;

		/* Tri et recherches */
		void sort();

};


#endif


