
#include "student.h"


Student & Student::operator = (const Student & s)
{
	if (this != &s)
	{
		first_name		= s.first_name;
		last_name		= s.last_name;
		phone_number	= s.phone_number;
		student_address = s.student_address;
		branche			= s.branche;
		mySemesterList  = s.mySemesterList;
	}
	return *this;
}


ostream & operator << (ostream & f, const Student & s)
{
	f << "Etudiant : " << s.getFirstName() << " " << s.getLastName()
			<< "(id=" << s.getId() << ")" << endl;
	f << " Telephone : " << s.getPhone() << endl;
	f << " Adresse : " << s.getAddress() << endl;
	f << " Branche : " << s.getBranche() << endl;
	
	f << "Liste des semestres : " << endl;
	list<Semestre> sem = s.mySemesterList;
	for(list<Semestre>::iterator i=sem.begin(); i!=sem.end(); i++)
	{
		f << *i;
	}
	f << endl;
	sem.clear();
	return f;
}


bool Student::operator == (const Student & s) const
{
	if(last_name != s.last_name)
		return false;
	if(first_name != s.first_name)
		return false;
	if(phone_number != s.phone_number)
		return false;
	return true;
}


bool Student::operator < (const Student & s) const
{
	if(last_name < s.last_name)
		return true;
	if((first_name < s.first_name) && (last_name == s.last_name))
		return true;
	return false;
}



bool Student::dropSemester(const int index)
{
	if(index<0 || index>=mySemesterList.size())
		return false;

	list<Semestre>::iterator it=mySemesterList.begin();
	for(int i=0; i<index; i++)
		it++;
	mySemesterList.erase(it);
	/*delete it;*/

	return true;
}



Semestre & Student::getSemester(const int index)
{
	if(index>=0 && index<mySemesterList.size())
	{
		list<Semestre>::iterator it=mySemesterList.begin();
		for(int i=0; i<index; i++)
			it++;
		return *it;
	}
}

Semestre & Student::getLastSemester()
{
	return getSemester(mySemesterList.size()-1);
}




/* Tri */
void Student::sort()
{
	mySemesterList.sort();
	for(list<Semestre>::iterator i=mySemesterList.begin(); i!=mySemesterList.end(); i++)
		i->sort();
}