

#ifndef _STUDENT_H_
#define _STUDENT_H_

/* includes */
#include "semestre.h"



class Student
{
	private:
		int id;
		string first_name;
		string last_name;
		string phone_number;
		string student_address; 
		string branche; //GI, GSM
		list<Semestre> mySemesterList;
	
	public:
		/* Diffrents Constructeurs */
		Student() : id(0), first_name(""), last_name(""), phone_number(""),
			student_address(""), branche("") {} 
		Student(int num, string firstn, string lastn, string phonen, string studenta, string branch) :
			id(num), first_name(firstn), last_name(lastn), phone_number(phonen),
			student_address(studenta), branche(branch) {}
		Student(int num, string firstn, string lastn, string phonen, string studenta, string branch, list<Semestre> listsem) :
			id(num), first_name(firstn), last_name(lastn), phone_number(phonen),
			student_address(studenta), branche(branch),
			mySemesterList(listsem) {}

		/* Destructeurs */
		~Student() {}

		/* Accesseurs */
		inline void setFirstName(string s) { first_name = s; }
		inline void setLastName(string s)  { last_name = s; }
		inline void setPhone(string s)  { phone_number = s; }
		inline void setAddress(string s)  { student_address = s; }
		inline void setBranche(string s)  { branche = s; }
		inline void setSemester(list<Semestre> sem) { mySemesterList = sem; }
		inline void setId(int i) { id = i; }

		inline string getFirstName() const { return first_name; }
		inline string getLastName()  const { return last_name; }
		inline string getPhone()  const { return phone_number; }
		inline string getAddress()  const { return student_address; }
		inline string getBranche()  const { return branche; }
		inline const list<Semestre> & getSemester() const { return mySemesterList; }
		inline int getId() const { return id; }

		/* Redfinition d'oprateurs */
		Student & operator = (const Student &);
		friend ostream & operator << (ostream &, const Student &);
		bool operator == (const Student &) const;
		bool operator < (const Student &) const;

		/* Gestion des Semestres */
		inline void addSemester(const Semestre & sem) { mySemesterList.push_back(sem); }
		bool dropSemester(const int);
		Semestre & getSemester(const int);
		Semestre & getLastSemester();
		inline int getNbSemester() { return mySemesterList.size(); }

		/* Tri et recherches */
		void sort();
};


#endif


