
#include "universite.h"
#include <wx/wx.h>

Universite & Universite::operator = (const Universite & s)
{
	if (this != &s)
	{
		myStudentList  = s.myStudentList;
	}
	return *this;
}


ostream & operator << (ostream & f, const Universite & s)
{
	list<Student> student = s.myStudentList;
	for(list<Student>::iterator i=student.begin(); i!=student.end(); i++)
	{
		f << *i;
	}
	f << endl;
	student.clear();
	return f;
}


bool Universite::dropStudent(const int index)
{
	if(index<0 || index>=myStudentList.size())
		return false;

	list<Student>::iterator it=myStudentList.begin();
	for(int i=0; i<index; i++)
		it++;
	myStudentList.erase(it);
	/*Student * s = it;
	delete s;*/

	return true;
}




Student & Universite::getStudent(const int index)
{
	if(index>=0 && index<myStudentList.size())
	{
		list<Student>::iterator it=myStudentList.begin();
		for(int i=0; i<index; i++)
			it++;
		return *it;
	}
}

Student & Universite::getLastStudent()
{
	return getStudent(myStudentList.size()-1);
}

void Universite::clean()
{
	for(list<Student>::iterator i=myStudentList.begin(); i!=myStudentList.end(); i++)
	{
		/*DESTRUCTION ETUDIANTS*/
	}
	myStudentList.clear();
}



/* _ _ _ _ _ _ _ Gestion XML _ _ _ _ _ _ _ _ _ */


string getTextXML(DOMElement *element, string nameSubElement, int index)
{
	DOMNodeList *node = element->getElementsByTagName(XMLString::transcode(nameSubElement.c_str()));
	DOMNode *textSubNode= node->item(index)->getFirstChild();
	return XMLString::transcode(textSubNode->getNodeValue());
}

string getAttributeXML(DOMElement *element, string nameSubElement, int index, string nameAttribute)
{
	DOMNodeList *node = element->getElementsByTagName(XMLString::transcode(nameSubElement.c_str()));
	DOMElement *subElement = (DOMElement *)node->item(index);
	return XMLString::transcode(subElement->getAttribute(XMLString::transcode(nameAttribute.c_str())));
}





bool Universite::chargeXML(const string & file)
{

	XMLPlatformUtils::Initialize();
	XercesDOMParser *parser = new XercesDOMParser;
	parser->parse(file.c_str());

	DOMElement *repertoire = parser->getDocument()->getDocumentElement();
	DOMNodeList *etudiants = repertoire->getElementsByTagName(XMLString::transcode(ETUDIANT_XML_TAG));
	for (int i=0; i<etudiants->getLength(); i++)
	{
		DOMElement *currentStudent = (DOMElement *)etudiants->item(i);
		myStudentList.push_back(Student(
			atoi(getTextXML(currentStudent, "ID", 0).c_str()),
			getTextXML(currentStudent, "NOM", 0),
			getTextXML(currentStudent, "PRENOM", 0),
			getTextXML(currentStudent, "TELEPHONE", 0),
			getTextXML(currentStudent, "ADRESSE", 0),
			getTextXML(currentStudent, "BRANCHE", 0)
		));


		DOMNodeList *semestres = currentStudent->getElementsByTagName(XMLString::transcode("SEMESTRE"));
		for (int j=0; j<semestres->getLength(); j++)
		{
			DOMElement *currentSem = (DOMElement *)semestres->item(j);
			getLastStudent().addSemester(Semestre(
				getTextXML(currentSem, "NOMBRE", 0),
				(getTextXML(currentSem, "SAISON", 0) == SEASON_1) ? false : true
			));


			DOMNodeList *uvs = currentSem->getElementsByTagName(XMLString::transcode("UV"));
			for (int k=0; k<uvs->getLength(); k++)
			{
				DOMElement *currentUV = (DOMElement *)uvs->item(k);
				getLastStudent().getLastSemester().addUV(Uv(
					getTextXML(currentUV, "NOMUV", 0),
					getTextXML(currentUV, "NOTE", 0)
				));
			}
		}
	}

	delete parser;
	XMLPlatformUtils::Terminate();
	return true;
}

bool Universite::sauvegardeXML(const string & file)
{
	XMLPlatformUtils::Initialize();
	XercesDOMParser *parser = new XercesDOMParser;
	parser->parse(file.c_str());//PATTERN_XML_FILE);

	DOMDocument *doc = parser->getDocument();
	DOMElement *nouveauEtudiant;
	DOMElement *nouveauSemestre;
	DOMElement *nouvelUV;
	wxMessageBox(file.c_str());
	for(int i=0; i<getNbStudent(); i++)
	{

		nouveauEtudiant = doc->createElement(XMLString::transcode(ETUDIANT_XML_TAG));
		DOMElement *element;
		// id  
		element = doc->createElement(XMLString::transcode("ID"));
		element->appendChild(doc->createTextNode(XMLString::transcode(to_string(getStudent(i).getId()).c_str())));
		nouveauEtudiant->appendChild(element);
		// nom  
		element = doc->createElement(XMLString::transcode("NOM"));
		element->appendChild(doc->createTextNode(XMLString::transcode(getStudent(i).getLastName().c_str())));
		nouveauEtudiant->appendChild(element);
		// prnom
		element = doc->createElement(XMLString::transcode("PRENOM"));
		element->appendChild(doc->createTextNode(XMLString::transcode(getStudent(i).getFirstName().c_str())));
		nouveauEtudiant->appendChild(element);
		// tlphone
		element = doc->createElement(XMLString::transcode("TELEPHONE"));
		element->appendChild(doc->createTextNode(XMLString::transcode(getStudent(i).getPhone().c_str())));
		nouveauEtudiant->appendChild(element);
		// adresse
		element = doc->createElement(XMLString::transcode("ADRESSE"));
		element->appendChild(doc->createTextNode(XMLString::transcode(getStudent(i).getAddress().c_str())));
		nouveauEtudiant->appendChild(element);
		// branche
		element = doc->createElement(XMLString::transcode("BRANCHE"));
		element->appendChild(doc->createTextNode(XMLString::transcode(getStudent(i).getBranche().c_str())));
		nouveauEtudiant->appendChild(element);


		for (int j=0; j<getStudent(i).getNbSemester(); j++)
		{
			nouveauSemestre = doc->createElement(XMLString::transcode("SEMESTRE"));
			DOMElement *elt;
			
			// nombre
			elt = doc->createElement(XMLString::transcode("NOMBRE"));
			elt->appendChild(doc->createTextNode(XMLString::transcode(getStudent(i).getSemester(j).getNumber().c_str())));
			nouveauSemestre->appendChild(elt);
			// saison
			elt = doc->createElement(XMLString::transcode("SAISON"));
			elt->appendChild(doc->createTextNode(XMLString::transcode(
				(getStudent(i).getSemester(j).getSeason()) ? SEASON_2: SEASON_1)));
			nouveauSemestre->appendChild(elt);

			for (int k=0; k<getStudent(i).getSemester(j).getNbUVs(); k++)
			{
				nouvelUV = doc->createElement(XMLString::transcode("UV"));
				DOMElement *elt2;

				//codeUV
				elt2 = doc->createElement(XMLString::transcode("NOMUV"));
				elt2->appendChild(doc->createTextNode(XMLString::transcode(getStudent(i).getSemester(j).getUV(k).getCodeUv().c_str())));
				nouvelUV->appendChild(elt2);

				//Resultat
				elt2 = doc->createElement(XMLString::transcode("NOTE"));
				elt2->appendChild(doc->createTextNode(XMLString::transcode(getStudent(i).getSemester(j).getUV(k).getResultat().c_str())));
				nouvelUV->appendChild(elt2);

				nouveauSemestre->appendChild(nouvelUV);
			}

			nouveauEtudiant->appendChild(nouveauSemestre);
		}


		doc->getDocumentElement()->appendChild(nouveauEtudiant);
	}


	// get a serializer, an instance of DOMWriter
	XMLCh tempStr[100];
	XMLString::transcode("LS", tempStr, 99);
	DOMImplementation *impl          = DOMImplementationRegistry::getDOMImplementation(tempStr);
	DOMWriter         *theSerializer = ((DOMImplementationLS*)impl)->createDOMWriter();

	//  XMLFormatTarget *sortieSurTerminal = new StdOutFormatTarget();
	remove(file.c_str());
	XMLFormatTarget *sortieDansUnFichier = new LocalFileFormatTarget(file.c_str());

	theSerializer->writeNode(sortieDansUnFichier, *doc);

	delete theSerializer;
	delete sortieDansUnFichier;

	delete parser;
	XMLPlatformUtils::Terminate();

	return true;
}





/* Tri */
void Universite::sort()
{
	myStudentList.sort();
	for(list<Student>::iterator i=myStudentList.begin(); i!=myStudentList.end(); i++)
		i->sort();
}

