

#ifndef _UNIVERSITE_H_
#define _UNIVERSITE_H_

/* includes */
#include "student.h"
#include <xercesc/dom/DOM.hpp>
#include <xercesc/parsers/XercesDOMParser.hpp>
#include <xercesc/framework/LocalFileFormatTarget.hpp>

#include <iostream>
#include <string>
#include <list>


XERCES_CPP_NAMESPACE_USE
using namespace std;


#define ETUDIANT_XML_TAG "ETUDIANT"
#define PATTERN_XML_FILE "default_db.xml"


/* Poour convertir un 'in' en 'String' */
#include "to_string.h"



class Universite
{
	private:
		list<Student> myStudentList;
	
	public:
		/* Diffrents Constructeurs */
		Universite() {} 

		/* Destructeurs */
		~Universite() { myStudentList.clear(); }

		/* Accesseurs */
		inline void setStudent(list<Student> s) { myStudentList = s; }
		inline const list<Student> & getStudent() const { return myStudentList; }

		/* Redfinition d'oprateurs */
		Universite & operator = (const Universite &);
		friend ostream & operator << (ostream &, const Universite &);

		/* Gestion des Etudiants */
		inline void addStudent(Student & s)
		{
			if(s.getId() == 0) // l'Id doit tre modifi
				s.setId(myStudentList.size()+1); // l'Id devient sa position
			myStudentList.push_back(s);
		}
		bool dropStudent(const int);
		Student & getStudent(const int);
		Student & getLastStudent();
		inline int getNbStudent() { return myStudentList.size(); }
		void clean();

		/* Gestion XML */
		bool chargeXML(const string &);
		bool sauvegardeXML(const string &);


		/* Tri et recherches */
		void sort();
};


#endif


